routes/web.php
<?php

use App\Http\Controllers\admin\CommonController;
use App\Http\Controllers\Admin\RoleController;
use App\Http\Controllers\admin\UsersController;
use App\Http\Controllers\admin\ProductsController;
use App\Http\Controllers\admin\OrderController;
use App\Http\Controllers\admin\PaymentsController;
use App\Http\Controllers\Auth\LoginController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\SettingsController;
use App\Http\Controllers\HomeController;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();
Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
Route::get('/orders', [App\Http\Controllers\HomeController::class, 'orders'])->name('orders');
Route::get('/payments', [App\Http\Controllers\HomeController::class, 'payments'])->name('payments');
Route::get('/items', [App\Http\Controllers\HomeController::class, 'items'])->name('items');
Route::get('/settings', [App\Http\Controllers\HomeController::class, 'settings'])->name('settings');
Route::get('/darkmode-switch/{mode}', [App\Http\Controllers\HomeController::class, 'darkmodeSwitch'])->name('darkmode-switch');
Route::post('user-login', [LoginController::class, 'userLogin'])->name('user-login');
Route::post('user-signup', [LoginController::class, 'userSignup'])->name('user-signup');

// Admin Routes
Route::get('/products', [App\Http\Controllers\HomeController::class, 'products'])->name('products');
Route::post('/create-product', [App\Http\Controllers\HomeController::class, 'createProduct'])->name('create-product');
Route::get('/all-orders', [App\Http\Controllers\HomeController::class, 'allOrders'])->name('all-orders');
Route::post('/create-order', [App\Http\Controllers\HomeController::class, 'createOrder'])->name('create-order');
Route::prefix('admin')->group(function () {
    Route::group(['middleware' => 'auth:web'], function () {
        Route::get('/settings', [HomeController::class, 'index']);
        Route::match(['get', 'post'], '/change-password', [SettingsController::class, 'change_password'])->name('change_password');
        Route::post('/update-settings', [SettingsController::class, 'update']);
        Route::resource('roles', RoleController::class);
        Route::resource('users', UsersController::class);
        Route::get('delete/{route}/{id}', [CommonController::class, 'delete'])->name('delete');
        // Route::resource('products', ProductsController::class);
        Route::post('get-product-value', [ProductsController::class, 'getProductValue'])->name('getProductValue');
        Route::resource('orders', OrderController::class);
        Route::resource('payments', PaymentsController::class);
        Route::post('get-append-rows', [OrderController::class, 'getAppendedRows'])->name('getAppendedRows');
        Route::get('getProducts', [ProductsController::class, 'getProducts'])->name('getProducts');
        Route::post('app-order', [OrderController::class, 'appOrder'])->name('app-order');
    });
});

app/Http/Controllers/admin/RoleController.php
<?php
namespace App\Http\Controllers\Admin;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;
use Yajra\DataTables\Facades\DataTables;
class RoleController extends Controller
{   
    public function index()
    {   
        // if (!auth()->user()->can('administration')) {
        //     abort(403, 'Unauthorized action.');
        // }
        if (request()->ajax()) {
            $roles = Role::select(['name', 'id']);
            return DataTables::of($roles)
                ->addColumn('action', function ($row) {
                        $action = '';
                        // if (auth()->user()->can('administration')) {
                            $action .= '<a href="'.url('admin/roles').'/'.$row->id.'/edit" class="btn btn-xs btn-primary"><i class="fa fa-edit"></i> EDIT</a>';
                        // }
                        // if (auth()->user()->can('administration')) {
                        $action .= '&nbsp
                        <button data-href="'.route('delete',['roles',$row->id]).'" class="btn btn-xs btn-primary btn-modal"><i class="fa fa-trash"></i></button>';
                        // }
                        return $action;
                })
                ->removeColumn('id')
                ->rawColumns([1])
                ->make(false);
        }
        return view('admin.role.index');
    }
    public function create()
    {   
        // if (!auth()->user()->can('administration')) {
        //     abort(403, 'Unauthorized action.');
        // }
        $permission = Permission::select('id','name')->get();
        return view('admin.role.create')->with(compact('permission'));
    }
    public function store(Request $request)
    {
        // if (!auth()->user()->can('administration')) {
        //     abort(403, 'Unauthorized action.');
        // }
        try {
            $role_name = $request->input('name');
            $permissions = $request->input('permissions');
            $count = Role::where('name', $role_name)->count();
            if ($count == 0) {
                $role = Role::create([
                            'name' => $role_name ,
                        ]);
                $this->__createPermissionIfNotExists($permissions);
                if (!empty($permissions)) {
                    $role->syncPermissions($permissions);
                }
                $output = ['status' => 'success','message' =>'successfully added'];
            } else {
                $output = ['status' => 'warning','message' =>'Role already exist'];
            }
        } catch (\Exception $e) {
            $output = ['status' => 'danger','message' =>$e->getMessage()];
        }
        return redirect('admin/roles')->with($output);
    }
    public function edit($id)
    {   
        // if (!auth()->user()->can('administration')) {
        //     abort(403, 'Unauthorized action.');
        // }
        $permission = Permission::select('id','name')->get();
        $role = Role::with(['permissions'])->find($id);
        $role_permissions = [];
        foreach ($role->permissions as $role_perm) {
            $role_permissions[] = $role_perm->name;
        }
        return view('admin.role.edit')->with(compact('role', 'role_permissions','permission'));
    }
    public function update(Request $request, $id)
    {
        // if (!auth()->user()->can('administration')) {
        //     abort(403, 'Unauthorized action.');
        // }
        try {
            $role_name = $request->input('name');
            $permissions = $request->input('permissions');
            $count = Role::where('name', $role_name)
                        ->where('id', '!=', $id)
                        ->count();
            if ($count == 0) {
                $role = Role::findOrFail($id);
                if (!$role->is_default || $role->name == 'Cashier') {
                    if ($role->name == 'Cashier') {
                        $role->is_default = 0;
                    }
                    $role->name = $role_name;
                    $role->save();
                    $this->__createPermissionIfNotExists($permissions);
                    if (!empty($permissions)) {
                        $role->syncPermissions($permissions);
                    }
                    $output = ['status' => 'success','message' =>'successfully updated'];
                } else {
                    $output = ['status' => 'warning','message' =>'default role'];
                }
            } else {
                $output = ['status' => 'danger','message' =>'role exist'];
            }
        } catch (\Exception $e) {
            $output = ['status' => false,'message' =>$e->getMessage()];
        }
        return redirect('admin/roles')->with($output);
    }

    private function __createPermissionIfNotExists($permissions)
    {
        $exising_permissions = Permission::whereIn('name', $permissions)
                                    ->pluck('name')
                                    ->toArray();
        
        $non_existing_permissions = array_diff($permissions, $exising_permissions);
        if (!empty($non_existing_permissions)) {
            foreach ($non_existing_permissions as $new_permission) {
                $time_stamp = now();
                Permission::create([
                    'name' => $new_permission,
                    'guard_name' => 'admin'
                ]);
            }
        }
    }
    public function destroy($id)
    {   
        // if (!auth()->user()->can('administration')) {
        //     return ['success' => false,'msg' => 'Unauthorised access'];
        // }
        if (request()->ajax()) {
            try {
                $roles = Role::findOrFail($id);
                $roles->delete();
                $output = ['success' => true,'msg' =>'successfully deleted'];
            } catch (\Exception $e) {
                $output = ['success' => false,'msg' => $e->getMessage()];
            }
            return $output;
        }
    }
}

resources/views/admin/role/create.blade.php
@include('admin.layouts.sidebar')
<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            {{-- @if (auth()->user()->can('roles')) --}}
                {{-- <a class="btn btn-primary" href="{{route('roles.create')}}"><i class="fa fa-plus"></i> ADD</a> --}}
            {{-- @endif --}}
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="{{url('admin')}}">HOME</a></li>
                <li class="breadcrumb-item"><a href="{{route('roles.index')}}">ROLES</a></li>
                <li class="breadcrumb-item active">CREATE</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12">
            <!-- general form elements -->
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">ROLES</h3>
                </div>
                <div class="card-body">
                    <div id="example2_wrapper" class="dataTables_wrapper dt-bootstrap4">
                        <div class="row">
                            <div class="col-sm-12">
                                <form method="POST" action="{{route('roles.store')}}" accept-charset="UTF-8" id="role_add_form">
                                    @csrf 
                                    <div class="box-body">
                                    
                                        <div class="row">
                                            <div class="col-md-12">
                                                <div class="form-group">
                                                    <label for="name">ROLE NAME:*</label>
                                                    <input class="form-control" required placeholder="Role Name" name="name" type="text" id="name" autocomplete="off">
                                                </div>
                                            </div>
                                            <div class="col-md-12">
                                                <table class="table table-bordered table-striped">
                                                    <thead>
                                                        <tr>
                                                            <th>PERMISSION</th>
                                                            <th>CHECK</th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                        @if (!empty($permission))
                                                            @foreach ($permission as $v)
                                                                <tr>
                                                                    <td>{{$v['name']}}</td>
                                                                    <td><input class="input-icheck" name="permissions[]" type="checkbox" value="{{$v['name']}}"></td>
                                                                        
                                                                </tr>
                                                            @endforeach
                                                        @endif
                                                        
                                                    </tbody>
                                                </table>
                                            </div>
                                        </div>
                                    
                                    </div>
                                    <!-- /.box-body -->
                                    <div class="box-footer">
                                        <button type="submit" class="btn btn-primary pull-right">SAVE</button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
          </div>
        </div>
      </div>
    </section>
</div>
@include('admin.layouts.footer')
<script >
    $("#mastersNav").addClass('active');
    $("#RolesNav").addClass('active');
</script>

resources/views/admin/role/edit.blade.php
@include('admin.layouts.sidebar')
<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            {{-- @if (auth()->user()->can('roles')) --}}
                {{-- <a class="btn btn-primary" href="{{route('roles.create')}}"><i class="fa fa-plus"></i> ADD</a> --}}
            {{-- @endif --}}
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="{{url('admin')}}">HOME</a></li>
                <li class="breadcrumb-item"><a href="{{route('roles.index')}}">ROLES</a></li>
                <li class="breadcrumb-item active">EDIT</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12">
            <!-- general form elements -->
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">ROLES</h3>
                </div>
                <div class="card-body">
                    <div id="example2_wrapper" class="dataTables_wrapper dt-bootstrap4">
                        <div class="row">
                            <div class="col-sm-12">
                                <form method="POST" action="{{url('admin/roles').'/'.$role->id}}" accept-charset="UTF-8" id="role_edit_form">
                                    <input name="_method" type="hidden" value="PUT">
                                    @csrf 
                                    <div class="box-body">
                                    
                                        <div class="row">
                                            <div class="col-md-12">
                                                <div class="form-group">
                                                    <label for="name">ROLE NAME:*</label>
                                                    <input class="form-control" value="{{$role->name}}" required placeholder="Role Name" name="name" type="text" id="name" autocomplete="off">
                                                </div>
                                            </div>
                                            <div class="col-md-12">
                                                <table class="table table-bordered table-striped">
                                                    <thead>
                                                        <tr>
                                                            <th>PERMISSION</th>
                                                            <th>CHECK</th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                        @if (!empty($permission))
                                                            @foreach ($permission as $v)
                                                                <tr>
                                                                    <td>{{$v['name']}}</td>
                                                                    <td><input class="input-icheck" name="permissions[]" type="checkbox" value="{{$v['name']}}" @if(in_array($v['name'], $role_permissions)) checked @endif></td>
                                                                        
                                                                </tr>
                                                            @endforeach
                                                        @endif
                                                        
                                                    </tbody>
                                                </table>
                                            </div>
                                        </div>
                                    
                                    </div>
                                    <!-- /.box-body -->
                                    <div class="box-footer">
                                        <button type="submit" class="btn btn-primary pull-right">SAVE</button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
          </div>
        </div>
      </div>
    </section>
</div>
@include('admin.layouts.footer')
<script >
    $("#mastersNav").addClass('active');
    $("#RolesNav").addClass('active');
</script>

resources/views/admin/role/index.blade.php
@include('admin.layouts.sidebar')
<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            {{-- @if (auth()->user()->can('roles')) --}}
                <a class="btn btn-primary" href="{{route('roles.create')}}"><i class="fa fa-plus"></i> ADD</a>
            {{-- @endif --}}
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="{{url('admin')}}">HOME</a></li>
                <li class="breadcrumb-item active">ROLES</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12">
            <!-- general form elements -->
            @if(Session::has('message'))
                <div class="alert alert-{{Session::get('status')}}" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    {{Session::get('message')}}
                </div>  
            @endif
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">ROLES</h3>
                </div>
                <div class="card-body">
                    <div id="example2_wrapper" class="dataTables_wrapper dt-bootstrap4">
                        <div class="row">
                            <div class="col-sm-12">
                                <table class="table table-bordered table-striped data-table" id="roles_table">
                                    <thead>
                                        <tr>
                                            <th>ROLES</th>
                                            <th>ACTION</th>
                                        </tr>
                                    </thead>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
          </div>
        </div>
      </div>
    </section>
</div>
{{-- delete modal start here--}}
<div class="modal fade" tabindex="-1" role="dialog" id="removeModal">
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h4 class="modal-title">REMOVE</h4>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
              
          </div>

          <form role="form" action="{{url('admin/roles')}}" method="post" id="removeForm">
              <div class="modal-body">
                  <p>This will be deleted! Are you sure?</p>
              </div>
              <div class="modal-footer">
                  <button type="button" class="btn btn-warning" data-dismiss="modal">CLOSE</button>
                  <button type="submit" class="btn btn-danger delete_button">DELETE</button>
              </div>
          </form>
    </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->
{{-- delete modal end here --}}
<div class="modal fade modal_class" tabindex="-1" role="dialog" aria-labelledby="gridSystemModalLabel"></div>
@include('admin.layouts.footer')
<script >
    $(document).ready( function(){
        var roles_table = $('#roles_table').DataTable({
            processing: true,
            serverSide: true,
            ajax: "{{route('roles.index')}}",
            buttons:[],
            columnDefs: [ {
                "targets": 1,
                "orderable": false,
                "searchable": false
            } ]
        });
    });
    $(document).unbind('submit').on('submit', 'form#createForm', function(e){
        e.preventDefault();
        $(this).find('button[type="submit"]').attr('disabled', true);
        var data = $(this).serialize();
        $.ajax({
            method: "post",
            url: $(this).attr("action"),
            dataType: "json",
            data: data,
            success:function(result){
                if(result.success == true){
                    $('#createModal').modal('hide');
                    toastr.success(result.msg);
                    $('.data-table').DataTable().ajax.reload();
                }else{
                    toastr.error(result.msg);
                }
            }
        });
    });
       function remove(id){
           $('.delete_button').removeAttr('disabled');
           $(document).unbind('submit').on('submit', 'form#removeForm', function(e){
               e.preventDefault();
               $(this).find('button[type="submit"]').attr('disabled', true);
               $.ajax({
                   method: "delete",
                   url: $(this).attr("action")+'/'+id,
                   dataType: "json",
                   data: {
                       "_token": "{{ csrf_token() }}",
                       "id":id,
                   },
                   success:function(result){
                       if(result.success == true){
                           $('#removeModal').modal('hide');
                           toastr.success(result.msg);
                           $('.data-table').DataTable().ajax.reload();
                       }else{
                           $('#removeModal').modal('hide');
                           toastr.error(result.msg);
                           $('.data-table').DataTable().ajax.reload();
   
                       }
                   }
               });
           });
       }

    $(document).unbind('submit').on('submit', 'form#createForm', function(e){
        e.preventDefault();
        $(this).find('button[type="submit"]').attr('disabled', true);
        var data = $(this).serialize();
        $.ajax({
            method: "post",
            url: $(this).attr("action"),
            dataType: "json",
            data: data,
            success:function(result){
                if(result.success == true){
                    $('div.modal_class').modal('hide');
                    toastr.success(result.msg);
                    $('.data-table').DataTable().ajax.reload();
                }else{
                    toastr.error(result.msg);
                }
            }
        });
    });

    $(document).on('click', 'button.edit_button', function() {
        $('div.modal_class').load($(this).data('href'), function() {
            $(this).modal('show');
            $('form#edit_form').submit(function(e) {
                $(this).find('button[type="submit"]').attr('disabled', true);
                e.preventDefault();
                var data = $(this).serialize();

                $.ajax({
                    method: 'POST',
                    url: $(this).attr('action'),
                    dataType: 'json',
                    data: data,
                    success: function(result) {
                        if (result.success === true) {
                            $('div.modal_class').modal('hide');
                            toastr.success(result.msg);
                            $('.data-table').DataTable().ajax.reload();
                        } else {
                            toastr.error(result.msg);
                        }
                    },
                });
            });
        });
    });
    $(document).on('click', '.btn-modal', function(e) {
        e.preventDefault();
        var container = $(this).data('container');
        $.ajax({
            url: $(this).data('href'),
            dataType: 'html',
            success: function(result) {
                $(container)
                    .html(result)
                    .modal('show');
            },
        });
    });
    $("#mastersNav").addClass('active');
    $("#jobtypesNav").addClass('active');
   </script>
   @include('admin.layouts.scripts')